-- market prices
require "utils"

Sorted_Item_Prices = {}

Market_Items = {}
Items_Stack_Sizes = {}

Items_List =
 {
"accumulator",
"advanced-circuit",
"arithmetic-combinator",
"assembling-machine-1",
"assembling-machine-2",
"assembling-machine-3",
"battery",
"battery-equipment",
"battery-mk2-equipment",
"beacon",
--"belt-immunity-equipment",
"big-electric-pole",
"boiler",
"burner-inserter",
"burner-mining-drill",
"centrifuge",
"chemical-plant",
"concrete",
"constant-combinator",
"construction-robot",
"decider-combinator",
"discharge-defense-equipment",
--"electric-energy-interface",
"electric-engine-unit",
"electric-furnace",
"electric-mining-drill",
"electronic-circuit",
"empty-barrel",
"energy-shield-equipment",
"energy-shield-mk2-equipment",
"engine-unit",
"exoskeleton-equipment",
"explosives",
"express-loader",
"express-splitter",
"express-transport-belt",
"express-underground-belt",
"fast-inserter",
"fast-loader",
"fast-splitter",
"fast-transport-belt",
"fast-underground-belt",
"filter-inserter",
"flamethrower-turret",
"flying-robot-frame",
"fusion-reactor-equipment",
"gate",
"green-wire",
"gun-turret",
"hazard-concrete",
"heat-exchanger",
"heat-pipe",
"inserter",
"iron-chest",
"iron-gear-wheel",
"lab",
"land-mine",
"laser-turret",
--"loader",
"logistic-chest-active-provider",
"logistic-chest-buffer",
"logistic-chest-passive-provider",
"logistic-chest-requester",
"logistic-chest-storage",
"logistic-robot",
"long-handed-inserter",
"low-density-structure",
"medium-electric-pole",
"night-vision-equipment",
"nuclear-fuel",
"nuclear-reactor",
"offshore-pump",
"oil-refinery",
"personal-laser-defense-equipment",
"personal-roboport-equipment",
"personal-roboport-mk2-equipment",
"pipe",
"pipe-to-ground",
--"player-port",
"power-switch",
"processing-unit",
"programmable-speaker",
"pump",
"pumpjack",
"radar",
"rail-chain-signal",
"rail-signal",
"red-wire",
"refined-concrete",
"refined-hazard-concrete",
"roboport",
"rocket-control-unit",
"rocket-fuel",
--"rocket-part",
"rocket-silo",
"satellite",
"small-electric-pole",
"small-lamp",
--"small-plane",
"solar-panel",
"solar-panel-equipment",
"splitter",
"stack-filter-inserter",
"stack-inserter",
"steam-engine",
"steam-turbine",
"steel-chest",
"steel-furnace",
"stone-furnace",
"stone-wall",
"storage-tank",
"substation",
"sulfur",
"train-stop",
"transport-belt",
"underground-belt",
"uranium-fuel-cell",
"wooden-chest",
"high-tech-science-pack",
"military-science-pack",
"production-science-pack",
"science-pack-1",
"science-pack-2",
"science-pack-3",
"space-science-pack",
"heavy-armor",
"light-armor",
"modular-armor",
"power-armor",
"power-armor-mk2",
"repair-pack",
"artillery-wagon-cannon",
"combat-shotgun",
"flamethrower",
"pistol",
"railgun",
"rocket-launcher",
"shotgun",
"submachine-gun",
"iron-axe",
"steel-axe",
"effectivity-module",
"effectivity-module-2",
"effectivity-module-3",
"productivity-module",
"productivity-module-2",
"productivity-module-3",
"speed-module",
"speed-module-2",
"speed-module-3",
}

-- basic prices
Market_Item_Prices = 
{
["raw-wood"]=1,
["wood"]=2,
["coal"]=2,
["copper-ore"]= 3,
["copper-plate"]=5,
["copper-cable"]=4,
["electronic-circuit"]=18,
["iron-ore"]=3,
["iron-plate"]=5,
["iron-stick"]=6,
["stone"]=2,
["stone-brick"]=4,
["landfill"]=5,
["uranium-ore"]=3,
["steel-plate"]=26,
["plastic-bar"]=25,
["uranium-235"]=25000,
["uranium-238"]=10,
["solid-fuel"]=30,
--["used-up-uranium-fuel-cell"]=45,
["crude-oil-barrel"]=50,
["heavy-oil-barrel"]=75,
["light-oil-barrel"]=75,
["lubricant-barrel"]=95,
["petroleum-gas-barrel"]=85,
["sulfuric-acid-barrel"]=115,
--["water-barrel"]=25,
--["science-pack-1"]=10,
--["science-pack-2"]=57,
--["science-pack-3"]=350,
}



--https://lua-api.factorio.com/latest/LuaItemPrototype.html
--https://lua-api.factorio.com/latest/LuaRecipePrototype.html
--[[An ingredient is a table

type :: string: "item" or "fluid".
name :: string: Prototype name of the required item or fluid.
amount :: uint: Amount of the item.
minimum_temperature :: uint (optional): The minimum fluid temperature required. Has no effect if type is '"item"'.
maximum_temperature :: uint (optional): The maximum fluid temperature allowed. Has no effect if type is '"item"'.
]]

--{type="item",name="",amount=1}

function Add_Item_Price(name)

local notPriced = {}
if Market_Item_Prices[name] == nil then table.insert(notPriced,name) end


while #notPriced > 0 do

local Tprice = 0 
 local RecipeName = notPriced[#notPriced]
 if game.recipe_prototypes[RecipeName] then
    local recipe = game.recipe_prototypes[RecipeName]
	local ingred = recipe.ingredients 
	local found = true	
		for k,i in pairs (ingred) do
		    
			local nome = i.name
			local tipo = i.type
			local qt   = i.amount
			
		
			if tipo=='item' then
			   local price = Market_Item_Prices[nome] 
				if  price == nil then 
				    --game.players[1].print (k..'   ! ' .. nome ..' nao econtrado')
					table.insert(notPriced,nome) -- adiciona no fim da fila
					found=false
					break
					else
					--game.players[1].print (k..'   ! ' .. nome .. ' $' ..price)
					Tprice=Tprice+1+ price * qt
					end

				else
				Tprice = Tprice + 10
				end -- tipo item
			
			end -- for k
	
	if found then
	    local stack_size=1
		if game.item_prototypes[RecipeName] and game.item_prototypes[RecipeName].stack_size then
		   stack_size=game.item_prototypes[RecipeName].stack_size
		   end
	    Items_Stack_Sizes[RecipeName] = stack_size
	    if Tprice >65000 then Tprice =65000 end
		Market_Item_Prices[RecipeName]=Tprice
		table.remove(notPriced,#notPriced)
		end
    else
	--game.players[1].print ('    NOTHING')
	break
	end -- tem recipe
	
 end -- notPriced
--game.players[1].print ('    ---> $ '.. Tprice)

end


function CreatePricesList()
for I, name in pairs (Items_List) do
    Add_Item_Price(name)
--	local price = Market_Item_Prices[name]
--	if price==nil then
--	    game.players[1].print ('!Warning! Item ' .. name .. ' has no price!')
--		else
--		local offer = {price = {{"coin", price}}, offer = {type = 'give-item', item = name}}
--		table.insert(Market_Items, offer)
			--if price >18000 then
			 --  game.players[1].print(name)  end 
			   --('!Warning! Item ' .. name .. ' is expensive ! $' .. price)
	--	end
   end

   
   
Items_Stack_Sizes["copper-plate"]= game.item_prototypes["copper-plate"].stack_size
Items_Stack_Sizes["copper-cable"]= game.item_prototypes["copper-cable"].stack_size
Items_Stack_Sizes["electronic-circuit"]= game.item_prototypes["electronic-circuit"].stack_size
Items_Stack_Sizes["iron-plate"]= game.item_prototypes["iron-plate"].stack_size
Items_Stack_Sizes["stone-brick"]= game.item_prototypes["stone-brick"].stack_size
Items_Stack_Sizes["landfill"]= game.item_prototypes["landfill"].stack_size
Items_Stack_Sizes["steel-plate"]= game.item_prototypes["steel-plate"].stack_size
Items_Stack_Sizes["plastic-bar"]= game.item_prototypes["plastic-bar"].stack_size
Items_Stack_Sizes["solid-fuel"]= game.item_prototypes["solid-fuel"].stack_size


for k,v in Sort_a_Table(Market_Item_Prices, function(t,a,b) return t[b] > t[a] end) do
    table.insert (Sorted_Item_Prices, {name=k, price=v})
	local offer = {price = {{"coin", v}}, offer = {type = 'give-item', item = k}}
	table.insert(Market_Items, offer)
end
 
-- SAVES ALL TO GLOBAL
global.Market_Items       = Market_Items
global.Sorted_Item_Prices = Sorted_Item_Prices
global.Market_Item_Prices = Market_Item_Prices
global.Items_Stack_Sizes  = Items_Stack_Sizes

 
end
